function [hpy]=hpfilter(y,lambda)
% gin 2018
% ginters.buss@gmail.com
% standard hp filter

% ------------------------------------------------------------
% INPUT:
% * y = a real (nx1) vector - the series to be filtered
% * lambda - the smoothing parameter (small; about 4 for quarterly data) 
% ------------------------------------------------------------
% OUPTUT:
% * hpy = vector (nX1) containing filtered data
% ------------------------------------------------------------
% ------------------------------------------------------------


t = size(y,1);
a = 6*lambda+1;
b = -4*lambda;
c = lambda;
d = [c,b,a];
d = ones(t,1)*d;
m = diag(d(:,3))+diag(d(1:t-1,2),1)+diag(d(1:t-1,2),-1);
m = m+diag(d(1:t-2,1),2)+diag(d(1:t-2,1),-2);

m(1,1) = 1+lambda;
m(1,2) = -2*lambda;
m(2,1) = -2*lambda;
m(2,2) = 5*lambda+1;
m(t-1,t-1) = 5*lambda+1;
m(t-1,t) = -2*lambda;
m(t,t-1) = -2*lambda;
m(t,t) = 1+lambda;
 
hpy = inv(m)*y;


